static const char *RcsId = "$Header: /net/phase/storp/projects/XRDsw/TANGO/GalilBox-1.2/src/GalilAxisClass.cpp,v 1.1.1.1 2006/03/23 15:29:00 xcsembed Exp $";


static const char *TagName = "$Name:  $";

static const char *FileName= "$Source: /net/phase/storp/projects/XRDsw/TANGO/GalilBox-1.2/src/GalilAxisClass.cpp,v $";

static const char *HttpServer= "http://controle/DeviceServer/doc/";

static const char *RCSfile = "$RCSfile: GalilAxisClass.cpp,v $";


//+=============================================================================
//
// file : 			 GalilAxisClass.cpp
//
// description : C++ source for the GalilAxisClass. A singleton
//							 class derived from DeviceClass. It implements the
//							 command list and all properties and methods required
//							 by the GalilAxis once per process.
//
// project :		 TANGO Device Server
//
// $Author: xcsembed $
//
// $Revision: 1.1.1.1 $
//
// $Log: GalilAxisClass.cpp,v $
// Revision 1.1.1.1  2006/03/23 15:29:00  xcsembed
// Hello
//
// Revision 1.8  2005/06/08 15:10:56  coquet
// les modifs 1.28 et 1.29 d�placaient le probl�me
// de mise a jour de l'etat dans axis_get_motion_status.
// remis axis_go_to_position dans l'ordre correct.
// modifie axis_get_motion_status.
//
// Revision 1.7  2005/04/22 12:14:13  coquet
// added method GetUserEncoderRatio
// used by GalilSlit to manage with slits with motors having differnet UserEncoderRatios.
//
// Revision 1.6  2005/04/22 12:13:39  coquet
// added method GetUserEncoderRatio
// used by GalilSlit to manage with slits with motors having differnet UserEncoderRatios.
//
// Revision 1.5  2004/04/13 12:46:20  coquet
// - .in() added for correction exception printing
// - Some Commands and attributes have been defined as "Expert's ones" to get a cleaner default  "Operator view"  in ATKPanel
//
// Revision 1.4  2004/04/06 07:27:05  coquet
// minor changes to LoadMicroCode
// changed alarm "microcode not running" priority
//
// Revision 1.3  2004/03/22 13:28:31	buteau
// const signatures in Socket classes
//
// Revision 1.2  2004/03/12 14:18:17	dupuy
// import des binaires
//
// Revision 1.1.1.1  2004/03/12 14:09:00	root
// initial import
//
//
// copyleft : 	European Synchrotron Radiation Facility
//							BP 220, Grenoble 38043
//							FRANCE
//
//-=============================================================================
//
//			This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//				 (c) - Software Engineering Group - ESRF
//=============================================================================


#include <tango.h>

#include <GalilAxis.h>
#include <GalilAxisClass.h>


namespace GalilAxis_ns
{
//+----------------------------------------------------------------------------
//
// method : 		GetUserEncoderRatioCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetUserEncoderRatioCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetUserEncoderRatioCmd::execute(): arrived" << endl;

	return insert((static_cast<GalilAxis *>(device))->get_user_encoder_ratio());
}

//+----------------------------------------------------------------------------
//
// method : 		AxisReadHWConfCmd::execute()
// 
// description :	method to trigger the execution of the command.
//								PLEASE DO NOT MODIFY this method core without pogo	 
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *AxisReadHWConfCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "AxisReadHWConfCmd::execute(): arrived" << endl;

	return insert((static_cast<GalilAxis *>(device))->axis_read_hwconf());
}

//+----------------------------------------------------------------------------
//
// method : 		MotorONCmd::execute()
// 
// description :	method to trigger the execution of the command.
//								PLEASE DO NOT MODIFY this method core without pogo	 
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *MotorONCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "MotorONCmd::execute(): arrived" << endl;

	((static_cast<GalilAxis *>(device))->motor_on());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		MotorOFFCmd::execute()
// 
// description :	method to trigger the execution of the command.
//								PLEASE DO NOT MODIFY this method core without pogo	 
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *MotorOFFCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "MotorOFFCmd::execute(): arrived" << endl;

	((static_cast<GalilAxis *>(device))->motor_off());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		AxisInitCmd::execute()
// 
// description :	method to trigger the execution of the command.
//								PLEASE DO NOT MODIFY this method core without pogo	 
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *AxisInitCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "AxisInitCmd::execute(): arrived" << endl;

	((static_cast<GalilAxis *>(device))->axis_init());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		DirectCmdCmd::execute()
// 
// description :	method to trigger the execution of the command.
//								PLEASE DO NOT MODIFY this method core without pogo	 
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *DirectCmdCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "DirectCmdCmd::execute(): arrived" << endl;

	Tango::DevString	argin;
	extract(in_any, argin);

	return insert((static_cast<GalilAxis *>(device))->direct_cmd(argin));
}

//+----------------------------------------------------------------------------
//
// method : 		AxisGetErrorStatusCmd::execute()
// 
// description :	method to trigger the execution of the command.
//								PLEASE DO NOT MODIFY this method core without pogo	 
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *AxisGetErrorStatusCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "AxisGetErrorStatusCmd::execute(): arrived" << endl;

	return insert((static_cast<GalilAxis *>(device))->axis_get_error_status());
}



//+----------------------------------------------------------------------------
//
// method : 		AxisForwardCmd::execute()
// 
// description :	method to trigger the execution of the command.
//								PLEASE DO NOT MODIFY this method core without pogo	 
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *AxisForwardCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "AxisForwardCmd::execute(): arrived" << endl;

	((static_cast<GalilAxis *>(device))->axis_forward());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		AxisStopCmd::execute()
// 
// description :	method to trigger the execution of the command.
//								PLEASE DO NOT MODIFY this method core without pogo	 
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *AxisStopCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "AxisStopCmd::execute(): arrived" << endl;

	((static_cast<GalilAxis *>(device))->axis_stop());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		AxisBackwardCmd::execute()
// 
// description :	method to trigger the execution of the command.
//								PLEASE DO NOT MODIFY this method core without pogo	 
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *AxisBackwardCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "AxisBackwardCmd::execute(): arrived" << endl;

	((static_cast<GalilAxis *>(device))->axis_backward());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		StartMicroCodeCmd::execute()
// 
// description :	method to trigger the execution of the command.
//								PLEASE DO NOT MODIFY this method core without pogo	 
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *StartMicroCodeCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "StartMicroCodeCmd::execute(): arrived" << endl;

	Tango::DevString	argin;
	extract(in_any, argin);

	((static_cast<GalilAxis *>(device))->start_micro_code(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		AxisGoToRelativePositionCmd::execute()
// 
// description :	method to trigger the execution of the command.
//								PLEASE DO NOT MODIFY this method core without pogo	 
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *AxisGoToRelativePositionCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "AxisGoToRelativePositionCmd::execute(): arrived" << endl;

	Tango::DevDouble	argin;
	extract(in_any, argin);

	((static_cast<GalilAxis *>(device))->axis_go_to_relative_position(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		AxisGoToPositionCmd::execute()
// 
// description :	method to trigger the execution of the command.
//								PLEASE DO NOT MODIFY this method core without pogo	 
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *AxisGoToPositionCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "AxisGoToPositionCmd::execute(): arrived" << endl;

	Tango::DevDouble	argin;
	extract(in_any, argin);

	((static_cast<GalilAxis *>(device))->axis_go_to_position(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		AxisOscillateCmd::execute()
// 
// description :	method to trigger the execution of the command.
//								PLEASE DO NOT MODIFY this method core without pogo	 
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *AxisOscillateCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "AxisOscillateCmd::execute(): arrived" << endl;

	Tango::DevDouble	argin;
	extract(in_any, argin);

	((static_cast<GalilAxis *>(device))->axis_oscillate(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		AxisDefinePositionCmd::execute()
// 
// description :	method to trigger the execution of the command.
//								PLEASE DO NOT MODIFY this method core without pogo	 
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *AxisDefinePositionCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "AxisDefinePositionCmd::execute(): arrived" << endl;

	Tango::DevDouble	argin;
	extract(in_any, argin);

	return insert((static_cast<GalilAxis *>(device))->axis_define_position(argin));
}

//+----------------------------------------------------------------------------
//
// method : 		AxisGetMotionStatusCmd::execute()
// 
// description :	method to trigger the execution of the command.
//								PLEASE DO NOT MODIFY this method core without pogo	 
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *AxisGetMotionStatusCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "AxisGetMotionStatusCmd::execute(): arrived" << endl;

	return insert((static_cast<GalilAxis *>(device))->axis_get_motion_status());
}

//+----------------------------------------------------------------------------
//
// method : 		AxisFindEdgeCmd::execute()
// 
// description :	method to trigger the execution of the command.
//								PLEASE DO NOT MODIFY this method core without pogo	 
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *AxisFindEdgeCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "AxisFindEdgeCmd::execute(): arrived" << endl;

	((static_cast<GalilAxis *>(device))->axis_find_edge());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		AxisFindIndexCmd::execute()
// 
// description :	method to trigger the execution of the command.
//								PLEASE DO NOT MODIFY this method core without pogo	 
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *AxisFindIndexCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "AxisFindIndexCmd::execute(): arrived" << endl;

	((static_cast<GalilAxis *>(device))->axis_find_index());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		AxisFindHomeCmd::execute()
// 
// description :	method to trigger the execution of the command.
//								PLEASE DO NOT MODIFY this method core without pogo	 
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *AxisFindHomeCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "AxisFindHomeCmd::execute(): arrived" << endl;

	((static_cast<GalilAxis *>(device))->axis_find_home());
	return new CORBA::Any();
}

//
//----------------------------------------------------------------
//	Initialize pointer for singleton pattern
//----------------------------------------------------------------
//
GalilAxisClass *GalilAxisClass::_instance = NULL;

//+----------------------------------------------------------------------------
//
// method : 		GalilAxisClass::GalilAxisClass(string &s)
// 
// description :	constructor for the GalilAxisClass
//
// in : - s : The class name
//
//-----------------------------------------------------------------------------
GalilAxisClass::GalilAxisClass(string &s):DeviceClass(s)
{

	cout2 << "Entering GalilAxisClass constructor" << endl;
	set_default_property();
//	write_class_property();
	
	cout2 << "Leaving GalilAxisClass constructor" << endl;

}
//+----------------------------------------------------------------------------
//
// method : 		GalilAxisClass::~GalilAxisClass()
// 
// description :	destructor for the GalilAxisClass
//
//-----------------------------------------------------------------------------
GalilAxisClass::~GalilAxisClass()
{

		cout2 << "Entering GalilAxisClass destructor" << endl;
	_instance = NULL;
}

//+----------------------------------------------------------------------------
//
// method : 		GalilAxisClass::instance
// 
// description : 	Create the object if not already done. Otherwise, just
//			return a pointer to the object
//
// in : - name : The class name
//
//-----------------------------------------------------------------------------
GalilAxisClass *GalilAxisClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new GalilAxisClass(s);
		}
		catch (bad_alloc)
		{
			throw;
		}		
	}		
	return _instance;
}

GalilAxisClass *GalilAxisClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}

//+----------------------------------------------------------------------------
//
// method : 		GalilAxisClass::command_factory
// 
// description : 	Create the command object(s) and store them in the 
//			command list
//
//-----------------------------------------------------------------------------
void GalilAxisClass::command_factory()
{
	command_list.push_back(new AxisForwardCmd("AxisForward",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new AxisStopCmd("AxisStop",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new AxisBackwardCmd("AxisBackward",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new StartMicroCodeCmd("StartMicroCode",
		Tango::DEV_STRING, Tango::DEV_VOID,
		"must be INIT reinit of all variables  or NOINIT just restart the microcode of GalilBox",
		"",
		Tango::EXPERT));
	command_list.push_back(new AxisGoToRelativePositionCmd("AxisGoToRelativePosition",
		Tango::DEV_DOUBLE, Tango::DEV_VOID,
		"Relative move in user unit",
		"",
		Tango::OPERATOR));
	command_list.push_back(new AxisGoToPositionCmd("AxisGoToPosition",
		Tango::DEV_DOUBLE, Tango::DEV_VOID,
		"Absolute position to reach in user units",
		"",
		Tango::OPERATOR));
	command_list.push_back(new AxisOscillateCmd("AxisOscillate",
		Tango::DEV_DOUBLE, Tango::DEV_VOID,
		"Oscillation amplitude in user unit",
		"",
		Tango::OPERATOR));
	command_list.push_back(new AxisDefinePositionCmd("AxisDefinePosition",
		Tango::DEV_DOUBLE, Tango::DEV_STRING,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new AxisGetMotionStatusCmd("AxisGetMotionStatus",
		Tango::DEV_VOID, Tango::DEV_LONG,
		"",
		"numerical code representing the status of the motion",
		Tango::EXPERT));
	command_list.push_back(new AxisFindEdgeCmd("AxisFindEdge",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::EXPERT));
	command_list.push_back(new AxisFindIndexCmd("AxisFindIndex",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::EXPERT));
	command_list.push_back(new AxisFindHomeCmd("AxisFindHome",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::EXPERT));
	command_list.push_back(new AxisGetErrorStatusCmd("AxisGetErrorStatus",
		Tango::DEV_VOID, Tango::DEV_LONG,
		"",
		"error code see command description",
		Tango::EXPERT));
	command_list.push_back(new DirectCmdCmd("DirectCmd",
		Tango::DEV_STRING, Tango::DEV_STRING,
		"",
		"",
		Tango::EXPERT));
	command_list.push_back(new AxisInitCmd("AxisInit",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::EXPERT));
	command_list.push_back(new MotorOFFCmd("MotorOFF",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::EXPERT));
	command_list.push_back(new MotorONCmd("MotorON",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::EXPERT));
	command_list.push_back(new AxisReadHWConfCmd("AxisReadHWConf",
		Tango::DEV_VOID, Tango::DEVVAR_STRINGARRAY,
		"",
		"",
		Tango::EXPERT));
	command_list.push_back(new GetUserEncoderRatioCmd("GetUserEncoderRatio",
		Tango::DEV_VOID, Tango::DEV_DOUBLE,
		"",
		"",
		Tango::OPERATOR));

	//	add polling if any
	for (unsigned int i=0 ; i<command_list.size(); i++)
	{
	}
}

//+----------------------------------------------------------------------------
//
// method : 		GalilAxisClass::get_class_property
// 
// description : 	Get the class property for specified name.
//
// in :		string	name : The property name
//
//+----------------------------------------------------------------------------
Tango::DbDatum GalilAxisClass::get_class_property(string &prop_name)
{
	for (int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		GalilAxisClass::get_default_device_property()
// 
// description : 	Return the default value for device property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum GalilAxisClass::get_default_device_property(string &prop_name)
{
	for (int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//+----------------------------------------------------------------------------
//
// method : 		GalilAxisClass::get_default_class_property()
// 
// description : 	Return the default value for class property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum GalilAxisClass::get_default_class_property(string &prop_name)
{
	for (int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		GalilAxisClass::device_factory
// 
// description : 	Create the device object(s) and store them in the 
//			device list
//
// in :		Tango::DevVarStringArray *devlist_ptr : The device name list
//
//-----------------------------------------------------------------------------
void GalilAxisClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{

	//	Create all devices.(Automatic code generation)
	//-------------------------------------------------------------
	for (unsigned long i=0 ; i < devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
						
		// Create devices and add it into the device list
		//----------------------------------------------------
		device_list.push_back(new GalilAxis(this, (*devlist_ptr)[i]));							 

		// Export device to the outside world
		// Check before if database used.
		//---------------------------------------------
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(device_list.back());
		else
			export_device(device_list.back(), (*devlist_ptr)[i]);
	}
	//	End of Automatic code generation
	//-------------------------------------------------------------

}
//+----------------------------------------------------------------------------
//	Method: GalilAxisClass::attribute_factory(vector<Tango::Attr *> &att_list)
//-----------------------------------------------------------------------------
void GalilAxisClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	//	Attribute : AxisCurrentPosition
	AxisCurrentPositionAttrib	*axis_current_position = new AxisCurrentPositionAttrib();
	Tango::UserDefaultAttrProp	axis_current_position_prop;
	axis_current_position_prop.set_label("Current position ");
	axis_current_position_prop.set_unit("UserUnits");
	axis_current_position_prop.set_description("Current position of Axis in UserUnits");
	axis_current_position->set_default_properties(axis_current_position_prop);
	att_list.push_back(axis_current_position);

	//	Attribute : AxisCurrentEncoderPosition
	AxisCurrentEncoderPositionAttrib	*axis_current_encoder_position = new AxisCurrentEncoderPositionAttrib();
	Tango::UserDefaultAttrProp	axis_current_encoder_position_prop;
	axis_current_encoder_position_prop.set_label("Encoder position");
	axis_current_encoder_position_prop.set_unit("EncoderUnits");
	axis_current_encoder_position_prop.set_description("Current position of Axis in EncoderUnits");
	axis_current_encoder_position->set_default_properties(axis_current_encoder_position_prop);
	axis_current_encoder_position->set_disp_level(Tango::EXPERT);
	att_list.push_back(axis_current_encoder_position);

	//	Attribute : AxisCurrentMotorPosition
	AxisCurrentMotorPositionAttrib	*axis_current_motor_position = new AxisCurrentMotorPositionAttrib();
	Tango::UserDefaultAttrProp	axis_current_motor_position_prop;
	axis_current_motor_position_prop.set_label("Motor position");
	axis_current_motor_position_prop.set_unit("steps");
	axis_current_motor_position_prop.set_description("Current position of Motor in Motor steps");
	axis_current_motor_position->set_default_properties(axis_current_motor_position_prop);
	axis_current_motor_position->set_disp_level(Tango::EXPERT);
	att_list.push_back(axis_current_motor_position);

	//	Attribute : AxisAcceleration
	AxisAccelerationAttrib	*axis_acceleration = new AxisAccelerationAttrib();
	Tango::UserDefaultAttrProp	axis_acceleration_prop;
	axis_acceleration_prop.set_label("Acceleration");
	axis_acceleration_prop.set_unit("UserUnits /sec�");
	axis_acceleration_prop.set_description("Acceleration for all movements in UserUnits /sec�");
	axis_acceleration->set_default_properties(axis_acceleration_prop);
	axis_acceleration->set_disp_level(Tango::EXPERT);
	att_list.push_back(axis_acceleration);

	//	Attribute : AxisDeceleration
	AxisDecelerationAttrib	*axis_deceleration = new AxisDecelerationAttrib();
	Tango::UserDefaultAttrProp	axis_deceleration_prop;
	axis_deceleration_prop.set_label("Deceleration");
	axis_deceleration_prop.set_unit("User Units/sec�");
	axis_deceleration_prop.set_description("Deceleration for all movements in UserUnits /sec�");
	axis_deceleration->set_default_properties(axis_deceleration_prop);
	axis_deceleration->set_disp_level(Tango::EXPERT);
	att_list.push_back(axis_deceleration);

	//	Attribute : AxisVelocity
	AxisVelocityAttrib	*axis_velocity = new AxisVelocityAttrib();
	Tango::UserDefaultAttrProp	axis_velocity_prop;
	axis_velocity_prop.set_label("Velocity");
	axis_velocity_prop.set_unit("User Unit/sec");
	axis_velocity_prop.set_description("Velocity for all movements in UserUnits /sec");
	axis_velocity->set_default_properties(axis_velocity_prop);
	axis_velocity->set_disp_level(Tango::EXPERT);
	att_list.push_back(axis_velocity);

	//	Attribute : AxisMotionAccuracy
	AxisMotionAccuracyAttrib	*axis_motion_accuracy = new AxisMotionAccuracyAttrib();
	Tango::UserDefaultAttrProp	axis_motion_accuracy_prop;
	axis_motion_accuracy_prop.set_label("Motion Accuracy");
	axis_motion_accuracy_prop.set_unit("User Unit");
	axis_motion_accuracy_prop.set_description("Accuracy of a moving:\ne.g: AxisMotionAccuracy=13; \nAxisCurrentPosition= 150 \nif AxisGoToPosition(160): No move because:\n160 - 150 < 13");
	axis_motion_accuracy->set_default_properties(axis_motion_accuracy_prop);
	axis_motion_accuracy->set_disp_level(Tango::EXPERT);
	att_list.push_back(axis_motion_accuracy);

	//	Attribute : AxisPercent
	AxisPercentAttrib	*axis_percent = new AxisPercentAttrib();
	Tango::UserDefaultAttrProp	axis_percent_prop;
	axis_percent_prop.set_label("Coefficient for successive approach positioning");
	axis_percent_prop.set_description("Coefficient for successive approach positioning");
	axis_percent->set_default_properties(axis_percent_prop);
	axis_percent->set_disp_level(Tango::EXPERT);
	att_list.push_back(axis_percent);

	//	Attribute : AxisRetry
	AxisRetryAttrib	*axis_retry = new AxisRetryAttrib();
	Tango::UserDefaultAttrProp	axis_retry_prop;
	axis_retry_prop.set_label("Number of retries");
	axis_retry_prop.set_description("Number of retries done by the GalilBox Internal \nClosedControl Loop Algorithm \n");
	axis_retry->set_default_properties(axis_retry_prop);
	axis_retry->set_disp_level(Tango::EXPERT);
	att_list.push_back(axis_retry);

	//	Attribute : AxisBacklash
	AxisBacklashAttrib	*axis_backlash = new AxisBacklashAttrib();
	Tango::UserDefaultAttrProp	axis_backlash_prop;
	axis_backlash_prop.set_label("Compensation for mechanical backlash ");
	axis_backlash_prop.set_description("Compensation for mechanical backlash by doing final move in the direction defined by AxisDirection");
	axis_backlash->set_default_properties(axis_backlash_prop);
	axis_backlash->set_disp_level(Tango::EXPERT);
	att_list.push_back(axis_backlash);

	//	Attribute : AxisDirection
	AxisDirectionAttrib	*axis_direction = new AxisDirectionAttrib();
	Tango::UserDefaultAttrProp	axis_direction_prop;
	axis_direction_prop.set_label("Direction of final move");
	axis_direction_prop.set_description("Direction of final move \n( for mechanical backlash compensation ). \nWrite : modification of direction\n\n0 : no mechanical backlash compensation\n1 : final move direction = direction as defined by Userdirection\n1 : final move direction = reverse direction as defined by Userdirection");
	axis_direction->set_default_properties(axis_direction_prop);
	axis_direction->set_disp_level(Tango::EXPERT);
	att_list.push_back(axis_direction);

	//	Attribute : AxisOffset
	AxisOffsetAttrib	*axis_offset = new AxisOffsetAttrib();
	Tango::UserDefaultAttrProp	axis_offset_prop;
	axis_offset_prop.set_label("Offset");
	axis_offset_prop.set_unit("User Unit");
	axis_offset_prop.set_standard_unit("User unit");
	axis_offset_prop.set_description("adds an Offset in user units to AxisCurrentPosition\nLets unchanged AxisCurrentEncoderPosition\nand AxisCurrentMotorPosition\nwhen a AxisGoToPosition is issued or AxisCurrentPosition is written,\n substracts the offset prior to calculate the destination position in encoder units\nThis attribute is saved in property CurrentOffset\nDefault : 0\n");
	axis_offset->set_default_properties(axis_offset_prop);
	axis_offset->set_disp_level(Tango::EXPERT);
	att_list.push_back(axis_offset);

	//	Attribute : UserDirection
	UserDirectionAttrib	*user_direction = new UserDirectionAttrib();
	Tango::UserDefaultAttrProp	user_direction_prop;
	user_direction_prop.set_label("UserDirection");
	user_direction_prop.set_max_value("1");
	user_direction_prop.set_min_value("-1");
	user_direction_prop.set_description("allows the user to adapt the direction of move\nto its needs.\nAffects all move commands\nAffects the CurrentPosition \npossible values 1 and -1\ndefault 1 ( the motorist direction is the user direction )");
	user_direction->set_default_properties(user_direction_prop);
	user_direction->set_disp_level(Tango::EXPERT);
	att_list.push_back(user_direction);

	//	Attribute : AxisCurrentVelocity
	AxisCurrentVelocityAttrib	*axis_current_velocity = new AxisCurrentVelocityAttrib();
	Tango::UserDefaultAttrProp	axis_current_velocity_prop;
	axis_current_velocity_prop.set_label("Current Velocity");
	axis_current_velocity_prop.set_unit("units/sec");
	axis_current_velocity_prop.set_description("current speed of the axis in user units / sec.\nprovided with a filter time average of .25 sec.\napproximate not instantaneous velocity");
	axis_current_velocity->set_default_properties(axis_current_velocity_prop);
	att_list.push_back(axis_current_velocity);

	//	Attribute : IsInitialised
	IsInitialisedAttrib	*is_initialised = new IsInitialisedAttrib();
	Tango::UserDefaultAttrProp	is_initialised_prop;
	is_initialised_prop.set_label("IsInitialised");
	is_initialised_prop.set_description("equals 0 if axis is not initialised\nequals 1if axis is initialized");
	is_initialised->set_default_properties(is_initialised_prop);
	is_initialised->set_disp_level(Tango::EXPERT);
	att_list.push_back(is_initialised);

	//	Attribute : LatchMode
	LatchModeAttrib	*latch_mode = new LatchModeAttrib();
	Tango::UserDefaultAttrProp	latch_mode_prop;
	latch_mode_prop.set_label("Capture of position mode");
	latch_mode_prop.set_description("for latching the position.\nSee description.html for description\nmust be 0 ( no latch ) default\nor 1 ( latch possible rearm latch by reading PositionLatch)");
	latch_mode->set_default_properties(latch_mode_prop);
	latch_mode->set_disp_level(Tango::EXPERT);
	att_list.push_back(latch_mode);

	//	Attribute : PositionLatched
	PositionLatchedAttrib	*position_latched = new PositionLatchedAttrib();
	Tango::UserDefaultAttrProp	position_latched_prop;
	position_latched_prop.set_label("Position Latched");
	position_latched_prop.set_unit("user units");
	position_latched_prop.set_description("position of the axis in user units latched\non an motion controller entry\nSee description.html to see how it works.");
	position_latched->set_default_properties(position_latched_prop);
	position_latched->set_disp_level(Tango::EXPERT);
	att_list.push_back(position_latched);

	//	Attribute : LatchOccured
	LatchOccuredAttrib	*latch_occured = new LatchOccuredAttrib();
	Tango::UserDefaultAttrProp	latch_occured_prop;
	latch_occured_prop.set_label("LatchOccured");
	latch_occured_prop.set_description("Is 1 if latch has occured.\nO if no.\nreset after a PositionLatch reading");
	latch_occured->set_default_properties(latch_occured_prop);
	latch_occured->set_disp_level(Tango::EXPERT);
	att_list.push_back(latch_occured);

}

//+----------------------------------------------------------------------------
//
// method : 	GalilAxisClass::set_default_property
// 
// description: Set default property (class and device) for wizard.
//              For each property, add to wizard property name and description
//              If default value has been set, add it to wizard property and
//              store it in a DbDatum.
//
//-----------------------------------------------------------------------------
void GalilAxisClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;

	vector<string>	vect_data;
	//	Set Default Class Properties
	//	Set Default Device Properties
	prop_name = "AxisNumber";
	prop_desc = "Number of the Axis on the motion controller (also called GalilBox).\nDepending on the GalilBox model it may be from 1 to 8\nOR ( new ) A to H (Galil terminology )\n1=A =X 2=B=Y 3 =C=Z 4=D=W 5=E 6=F 7=G 8=H";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "AxisBoxAttachement";
	prop_desc = "TANGO device name of the Galil motion controller ( also called GalilBox )\nwhich drives this axis <Br>\n<I> Example: </I> <B> microxas/motorisation/galilbox3 </B>";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "EncoderMotorRatio";
	prop_desc = "Number of Encoder steps for 1 Motor step. <BR>\n\n<I> Example: </I> If <B>EncoderMotorRatio=4 </B> , for a 1000 motor steps movement,\nEncoder value will change of 4000 steps\n\n<BR>\nWhen no Encoder is available for the Axis , this parameter must be set to 1. <BR>";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "UserEncoderRatio";
	prop_desc = "Property used to define the conversion between <I>EncoderUnits</I> to <I>UserUnits</I> <BR>\naccording to the following formula: <BR>\n\n<B> AxisCurrentPosition (<I> in UserUnits </I>) = AxisEncoderPosition\nUserEncoderRatio + CurrentOffset\n</B>\n\n<BR>\n<B> Exemple </B> :\n<UL>\n<LI> UserEncoderRatio = 0.1</LI>\n<LI> CurrentOffset = 33</LI>\n<LI> AxisEncoderPosition = 100 <I> EncoderUnits </I></LI>\n<LI> then AxisCurrentPosition=\n43 <I>UserUnits <I> </LI>\n</UL>";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "CurrentOffset";
	prop_desc = "Property used to define the conversion between <I>EncoderUnits</I> to <I>UserUnits</I> <BR>\naccording to the following formula: <BR>\n\n<B> AxisCurrentPosition (<I> in UserUnits </I>) = AxisEncoderPosition\nUserEncoderRatio + CurrentOffset\n</B>\n\n<BR>\n<B> Exemple </B> :\n<UL>\n<LI> UserEncoderRatio = 0.1</LI>\n<LI> CurrentOffset = 33</LI>\n<LI> AxisEncoderPosition = 100 <I> EncoderUnits </I></LI>\n<LI> then AxisCurrentPosition=\n43 <I>UserUnits <I> </LI>\n</UL>";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "CurrentAcceleration";
	prop_desc = "Property used to store the current AxisAcceleration value in TANGO DataBase.\nNot to be configured by user";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "CurrentDeceleration";
	prop_desc = "Property used to store the current AxisDeceleration value in TANGO DataBase.\nNot to be configured by user";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "CurrentVelocity";
	prop_desc = "Property used to store the current AxisVelocity value in TANGO DataBase.\nNot to be configured by user";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "CurrentPercent";
	prop_desc = "Property used to store the current AxisPercent value in TANGO DataBase.\nNot to be configured by user";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "CurrentMotionAccuracy";
	prop_desc = "Property used to store the current AxisAccuracy value in TANGO DataBase.\nNot to be configured by user";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "CurrentRetry";
	prop_desc = "Property used to store the current AxisRetry value in TANGO DataBase.\nNot to be configured by user";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "AxisEncoderType";
	prop_desc = "Type of Encoder connected to the axis:\n<UL>\n<LI> 0 for no encoder </LI>\n<LI> 1 for incremental encoder </LI>\n<LI> 2 for absolute encoder </LI>\n</UL>";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "CurrentBacklash";
	prop_desc = "Property used to store the current AxisBacklash value in TANGO DataBase.\nNot to be configured by user";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "CurrentDirection";
	prop_desc = "Property used to store the current AxisDirection value in TANGO DataBase.\nNot to be configured by user";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "AxisSmoothing";
	prop_desc = "Use this property to smooth acceleration/deceleration.\nUsefull for stepper motors drived in full step.\nrange : 0.5 ( no smoothing ) to 8.0 (max smoothing ) per steps of 1/32\nDefault : 0.5\nSee Galil command reference KS";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "AxisMotorDirection";
	prop_desc = "used to have uniform positive direction for motors\nrotate : positive is trigonometric direction\ntranslate : positive is UP or ....?\nThis applies to all movements ( AxisForward, AxisGoToPosition....)\n1 : servo motor\n-1 :servo motor with reverse polarity\n2 : stepper motor with active low step pulse\n-2: stepper motor with active high step pulse\n2.5 :stepper motor with reverse direction and active low step pulse\n-2.5 :stepper motor with reverse direction and active high step pulse\nDefault : 2\nSee Galil command reference MT";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "AxisEncoderDirection";
	prop_desc = "ONLY FOR INCREMENTAL ENCODERS !\nconfigures the encoder type and direction\nApplies to main and aux encoders.\nNOTE : for stepper motor operation ONLY USE THE MAIN ENCODER!\n____________________________________________________________________\nm= Main encoder type n= Aux encoder type\n-------------------------------------------------------------------------------------------------------------------------\n0 Normal quadrature 0 Normal quadrature\n1 Normal pulse and direction 4 Normal pulse and direction\n2 Reversed quadrature 8 Reversed quadrature\n3 Reversed pulse and direction 12 Reversed pulse and direction\ndefault : 0\nDo the sum of m and n\n\nSee Galil commmand reference CE";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "AxisForwardLimit";
	prop_desc = "This is the Motion controller software forward limit\nStops any movement passing that limit\n\ndefault : 1000000\nSee Galil command FL";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "AxisBackwardLimit";
	prop_desc = "Motion controller software backward limit.\ndefault : -1000000\nsee Galil command reference BL";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "CurrentUserDirection";
	prop_desc = "used to store the UserDirection attribute\nnot to be modified directly.";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "AbsoluteEncoderOffset";
	prop_desc = "in encoder unit, adds the specified offset to the CurrentEncoderPosition\nModifies the CurrentPosition\nUsed only for absolute encoders.";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "AbsoluteEncoderDirection";
	prop_desc = "allows motorist to change the direction of increment position on ABSOLUTE ENCODERS\nmust be 1 or -1\nDefault 1";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "AxisInitType";
	prop_desc = "for initialisation of the axis.\nNot relevant for axis with absolute encoders or axis without limit switches and without encoders\nThe axis will move regarding to its type and load the InitPosition property in the motion controller\ndescribes the type of init to be done regarding swiches and axis type\n0 : no initialisation possible\n1 : initialisation on HOME switch, uses the HM command of the motion controller\n2 : initialisation on LIMIT SWITCH BACKWARD (User Direction)\n4 : initialisation on LIMIT SWITCH FORWARD ( User Direction )\n3 : on TOP ZERO of the incremental encoder";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "AxisInitPosition";
	prop_desc = "position of the axis on its initialisation position\nsee AxisInitType and Desrver documentation\nin user units";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "MotoristMemo";
	prop_desc = "Makes nothing. For some memos for the motorist.";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "ServoPIDProp";
	prop_desc = "For Servo motors only ( DC or bruhless motors )\nproportionall componement of the PID error loop correction\nDefault : 6";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "ServoPIDInteg";
	prop_desc = "For Servo motors only ( DC or bruhsless motors )\nIntegral componement of the PID error loop correction\nDefault : 0";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "ServoPIDDeriv";
	prop_desc = "For Servo motors only ( DC or bruhsless motors )\nDerivate componement of the PID error loop correction\nDefault : 64";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "ServoPIDIntegLimit";
	prop_desc = "For Servo motors only ( DC or bruhsless motors )\nLimitation of the Integral componement of the PID error loop correction\nA negative parameter freezes the effect of the parameter during the move.\nDefault : 5.0";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "ErrorLimit";
	prop_desc = "Error limit sets the magnitude of the dynamic position error ( during the move ).\nWhen the limit is exceeded, the motor is disabled.\n-1 inhibits error limit.\nMust never be reached under normal operation, only in case\nof hardware jam ( motor, encoder, mechanics )\nDefault : -1\nMaximum : 32767";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

}
//+----------------------------------------------------------------------------
//
// method : 		GalilAxisClass::write_class_property
// 
// description : 	Set class description as property in database
//
//-----------------------------------------------------------------------------
void GalilAxisClass::write_class_property()
{
	//	First time, check if database used
	//--------------------------------------------
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("Axis");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("Device for driving a independant Step Motor Axis with a Motion Controller Galil");
	str_desc.push_back("DMC 2180");
	description << str_desc;
	data.push_back(description);
		
	//	put cvs location
	string	rcsId(RcsId);
	string	filename(classname);
	start = rcsId.find("/");
	if (start!=string::npos)
	{
		filename += "Class.cpp";
		end   = rcsId.find(filename);
		if (end>start)
		{
			string	strloc = rcsId.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	//	Get CVS tag revision
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	end   = tagname.find(endstr);
	if (end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//	Call database and and values
	//--------------------------------------------
	get_db_class()->put_property(data);
}

}	// namespace
