//=============================================================================
//
// file :         GalilAxisClass.h
//
// description :  Include for the GalilAxisClass root class.
//                This class is represents the singleton class for
//                the GalilAxis device class.
//                It contains all properties and methods which the 
//                GalilAxis requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// $Author: xcsembed $
//
// $Revision: 1.1.1.1 $
//
// $Log: GalilAxisClass.h,v $
// Revision 1.1.1.1  2006/03/23 15:29:00  xcsembed
// Hello
//
// Revision 1.7  2005/06/08 15:10:56  coquet
// les modifs 1.28 et 1.29 d�placaient le probl�me
// de mise a jour de l'etat dans axis_get_motion_status.
// remis axis_go_to_position dans l'ordre correct.
// modifie axis_get_motion_status.
//
// Revision 1.6  2005/04/22 12:14:13  coquet
// added method GetUserEncoderRatio
// used by GalilSlit to manage with slits with motors having differnet UserEncoderRatios.
//
// Revision 1.5  2005/04/22 12:13:39  coquet
// added method GetUserEncoderRatio
// used by GalilSlit to manage with slits with motors having differnet UserEncoderRatios.
//
// Revision 1.4  2004/04/13 12:46:20  coquet
// - .in() added for correction exception printing
// - Some Commands and attributes have been defined as "Expert's ones" to get a cleaner default  "Operator view"  in ATKPanel
//
// Revision 1.3  2004/03/22 13:28:31  buteau
// const signatures in Socket classes
//
// Revision 1.2  2004/03/12 14:18:17  dupuy
// import des binaires
//
// Revision 1.1.1.1  2004/03/12 14:09:00  root
// initial import
//
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#ifndef _GALILAXISCLASS_H
#define _GALILAXISCLASS_H

#include <tango.h>
#include <GalilAxis.h>


namespace GalilAxis_ns
{
//=====================================
//	Define classes for attributes
//=====================================
class LatchOccuredAttrib: public Tango::Attr
{
public:
	LatchOccuredAttrib():Attr("LatchOccured", Tango::DEV_SHORT, Tango::READ) {};
	~LatchOccuredAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GalilAxis *>(dev))->read_LatchOccured(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GalilAxis *>(dev))->is_LatchOccured_allowed(ty);}
};

class PositionLatchedAttrib: public Tango::Attr
{
public:
	PositionLatchedAttrib():Attr("PositionLatched", Tango::DEV_DOUBLE, Tango::READ) {};
	~PositionLatchedAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GalilAxis *>(dev))->read_PositionLatched(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GalilAxis *>(dev))->is_PositionLatched_allowed(ty);}
};

class LatchModeAttrib: public Tango::Attr
{
public:
	LatchModeAttrib():Attr("LatchMode", Tango::DEV_SHORT, Tango::READ_WRITE) {};
	~LatchModeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GalilAxis *>(dev))->read_LatchMode(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<GalilAxis *>(dev))->write_LatchMode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GalilAxis *>(dev))->is_LatchMode_allowed(ty);}
};

class IsInitialisedAttrib: public Tango::Attr
{
public:
	IsInitialisedAttrib():Attr("IsInitialised", Tango::DEV_SHORT, Tango::READ) {};
	~IsInitialisedAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GalilAxis *>(dev))->read_IsInitialised(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GalilAxis *>(dev))->is_IsInitialised_allowed(ty);}
};

class AxisCurrentVelocityAttrib: public Tango::Attr
{
public:
	AxisCurrentVelocityAttrib():Attr("AxisCurrentVelocity", Tango::DEV_DOUBLE, Tango::READ) {};
	~AxisCurrentVelocityAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GalilAxis *>(dev))->read_AxisCurrentVelocity(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GalilAxis *>(dev))->is_AxisCurrentVelocity_allowed(ty);}
};

class UserDirectionAttrib: public Tango::Attr
{
public:
	UserDirectionAttrib():Attr("UserDirection", Tango::DEV_SHORT, Tango::READ_WRITE) {};
	~UserDirectionAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GalilAxis *>(dev))->read_UserDirection(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<GalilAxis *>(dev))->write_UserDirection(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GalilAxis *>(dev))->is_UserDirection_allowed(ty);}
};

class AxisOffsetAttrib: public Tango::Attr
{
public:
	AxisOffsetAttrib():Attr("AxisOffset", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AxisOffsetAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GalilAxis *>(dev))->read_AxisOffset(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<GalilAxis *>(dev))->write_AxisOffset(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GalilAxis *>(dev))->is_AxisOffset_allowed(ty);}
};

class AxisDirectionAttrib: public Tango::Attr
{
public:
	AxisDirectionAttrib():Attr("AxisDirection", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AxisDirectionAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GalilAxis *>(dev))->read_AxisDirection(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<GalilAxis *>(dev))->write_AxisDirection(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GalilAxis *>(dev))->is_AxisDirection_allowed(ty);}
};

class AxisBacklashAttrib: public Tango::Attr
{
public:
	AxisBacklashAttrib():Attr("AxisBacklash", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AxisBacklashAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GalilAxis *>(dev))->read_AxisBacklash(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<GalilAxis *>(dev))->write_AxisBacklash(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GalilAxis *>(dev))->is_AxisBacklash_allowed(ty);}
};

class AxisRetryAttrib: public Tango::Attr
{
public:
	AxisRetryAttrib():Attr("AxisRetry", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AxisRetryAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GalilAxis *>(dev))->read_AxisRetry(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<GalilAxis *>(dev))->write_AxisRetry(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GalilAxis *>(dev))->is_AxisRetry_allowed(ty);}
};

class AxisPercentAttrib: public Tango::Attr
{
public:
	AxisPercentAttrib():Attr("AxisPercent", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AxisPercentAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GalilAxis *>(dev))->read_AxisPercent(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<GalilAxis *>(dev))->write_AxisPercent(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GalilAxis *>(dev))->is_AxisPercent_allowed(ty);}
};

class AxisMotionAccuracyAttrib: public Tango::Attr
{
public:
	AxisMotionAccuracyAttrib():Attr("AxisMotionAccuracy", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AxisMotionAccuracyAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GalilAxis *>(dev))->read_AxisMotionAccuracy(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<GalilAxis *>(dev))->write_AxisMotionAccuracy(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GalilAxis *>(dev))->is_AxisMotionAccuracy_allowed(ty);}
};

class AxisVelocityAttrib: public Tango::Attr
{
public:
	AxisVelocityAttrib():Attr("AxisVelocity", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AxisVelocityAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GalilAxis *>(dev))->read_AxisVelocity(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<GalilAxis *>(dev))->write_AxisVelocity(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GalilAxis *>(dev))->is_AxisVelocity_allowed(ty);}
};

class AxisDecelerationAttrib: public Tango::Attr
{
public:
	AxisDecelerationAttrib():Attr("AxisDeceleration", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AxisDecelerationAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GalilAxis *>(dev))->read_AxisDeceleration(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<GalilAxis *>(dev))->write_AxisDeceleration(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GalilAxis *>(dev))->is_AxisDeceleration_allowed(ty);}
};

class AxisAccelerationAttrib: public Tango::Attr
{
public:
	AxisAccelerationAttrib():Attr("AxisAcceleration", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AxisAccelerationAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GalilAxis *>(dev))->read_AxisAcceleration(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<GalilAxis *>(dev))->write_AxisAcceleration(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GalilAxis *>(dev))->is_AxisAcceleration_allowed(ty);}
};

class AxisCurrentMotorPositionAttrib: public Tango::Attr
{
public:
	AxisCurrentMotorPositionAttrib():Attr("AxisCurrentMotorPosition", Tango::DEV_LONG, Tango::READ) {};
	~AxisCurrentMotorPositionAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GalilAxis *>(dev))->read_AxisCurrentMotorPosition(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GalilAxis *>(dev))->is_AxisCurrentMotorPosition_allowed(ty);}
};

class AxisCurrentEncoderPositionAttrib: public Tango::Attr
{
public:
	AxisCurrentEncoderPositionAttrib():Attr("AxisCurrentEncoderPosition", Tango::DEV_LONG, Tango::READ) {};
	~AxisCurrentEncoderPositionAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GalilAxis *>(dev))->read_AxisCurrentEncoderPosition(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GalilAxis *>(dev))->is_AxisCurrentEncoderPosition_allowed(ty);}
};

class AxisCurrentPositionAttrib: public Tango::Attr
{
public:
	AxisCurrentPositionAttrib():Attr("AxisCurrentPosition", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AxisCurrentPositionAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GalilAxis *>(dev))->read_AxisCurrentPosition(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<GalilAxis *>(dev))->write_AxisCurrentPosition(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GalilAxis *>(dev))->is_AxisCurrentPosition_allowed(ty);}
};

//=========================================
//	Define classes for commands
//=========================================
class GetUserEncoderRatioCmd : public Tango::Command
{
public:
	GetUserEncoderRatioCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetUserEncoderRatioCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetUserEncoderRatioCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<GalilAxis *>(dev))->is_GetUserEncoderRatio_allowed(any);}
};



class AxisReadHWConfCmd : public Tango::Command
{
public:
	AxisReadHWConfCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisReadHWConfCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisReadHWConfCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<GalilAxis *>(dev))->is_AxisReadHWConf_allowed(any);}
};



class MotorONCmd : public Tango::Command
{
public:
	MotorONCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	MotorONCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~MotorONCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<GalilAxis *>(dev))->is_MotorON_allowed(any);}
};



class MotorOFFCmd : public Tango::Command
{
public:
	MotorOFFCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	MotorOFFCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~MotorOFFCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<GalilAxis *>(dev))->is_MotorOFF_allowed(any);}
};



class AxisInitCmd : public Tango::Command
{
public:
	AxisInitCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisInitCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisInitCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<GalilAxis *>(dev))->is_AxisInit_allowed(any);}
};



class DirectCmdCmd : public Tango::Command
{
public:
	DirectCmdCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	DirectCmdCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~DirectCmdCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<GalilAxis *>(dev))->is_DirectCmd_allowed(any);}
};



class AxisGetErrorStatusCmd : public Tango::Command
{
public:
	AxisGetErrorStatusCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisGetErrorStatusCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisGetErrorStatusCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<GalilAxis *>(dev))->is_AxisGetErrorStatus_allowed(any);}
};



class AxisFindHomeCmd : public Tango::Command
{
public:
	AxisFindHomeCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisFindHomeCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisFindHomeCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<GalilAxis *>(dev))->is_AxisFindHome_allowed(any);}
};



class AxisFindIndexCmd : public Tango::Command
{
public:
	AxisFindIndexCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisFindIndexCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisFindIndexCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<GalilAxis *>(dev))->is_AxisFindIndex_allowed(any);}
};



class AxisFindEdgeCmd : public Tango::Command
{
public:
	AxisFindEdgeCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisFindEdgeCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisFindEdgeCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<GalilAxis *>(dev))->is_AxisFindEdge_allowed(any);}
};



class AxisGetMotionStatusCmd : public Tango::Command
{
public:
	AxisGetMotionStatusCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisGetMotionStatusCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisGetMotionStatusCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<GalilAxis *>(dev))->is_AxisGetMotionStatus_allowed(any);}
};



class AxisDefinePositionCmd : public Tango::Command
{
public:
	AxisDefinePositionCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisDefinePositionCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisDefinePositionCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<GalilAxis *>(dev))->is_AxisDefinePosition_allowed(any);}
};



class AxisOscillateCmd : public Tango::Command
{
public:
	AxisOscillateCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisOscillateCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisOscillateCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<GalilAxis *>(dev))->is_AxisOscillate_allowed(any);}
};



class AxisGoToPositionCmd : public Tango::Command
{
public:
	AxisGoToPositionCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisGoToPositionCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisGoToPositionCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<GalilAxis *>(dev))->is_AxisGoToPosition_allowed(any);}
};



class AxisGoToRelativePositionCmd : public Tango::Command
{
public:
	AxisGoToRelativePositionCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisGoToRelativePositionCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisGoToRelativePositionCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<GalilAxis *>(dev))->is_AxisGoToRelativePosition_allowed(any);}
};



class StartMicroCodeCmd : public Tango::Command
{
public:
	StartMicroCodeCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StartMicroCodeCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StartMicroCodeCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<GalilAxis *>(dev))->is_StartMicroCode_allowed(any);}
};



class AxisBackwardCmd : public Tango::Command
{
public:
	AxisBackwardCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisBackwardCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisBackwardCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<GalilAxis *>(dev))->is_AxisBackward_allowed(any);}
};



class AxisStopCmd : public Tango::Command
{
public:
	AxisStopCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisStopCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisStopCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<GalilAxis *>(dev))->is_AxisStop_allowed(any);}
};



class AxisForwardCmd : public Tango::Command
{
public:
	AxisForwardCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisForwardCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisForwardCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<GalilAxis *>(dev))->is_AxisForward_allowed(any);}
};



//
// The GalilAxisClass singleton definition
//

class GalilAxisClass : public Tango::DeviceClass
{
public:

//	add your own data members here
//------------------------------------

public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static GalilAxisClass *init(const char *);
	static GalilAxisClass *instance();
	~GalilAxisClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	GalilAxisClass(string &);
	static GalilAxisClass *_instance;
	void command_factory();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace GalilAxis_ns

#endif // _GALILAXISCLASS_H
