static const char *RcsId = "$Header: /net/phase/storp/projects/XRDsw/TANGO/GalilBox-1.2/src/main.cpp,v 1.1.1.1 2006/03/23 15:28:59 xcsembed Exp $";
//+=============================================================================
//
// file :        main.cpp
//
// description : C++ source for a TANGO device server main.
//               The main rule is to initialise (and create) the Tango
//               system and to create the DServerClass singleton.
//               The main should be the same for every Tango device server.
//
// project :     TANGO Device Server
//
// $Author: xcsembed $
//
// $Revision: 1.1.1.1 $ $
//
// $Log: main.cpp,v $
// Revision 1.1.1.1  2006/03/23 15:28:59  xcsembed
// Hello
//
// Revision 1.7  2005/06/08 15:10:56  coquet
// les modifs 1.28 et 1.29 dplacaient le problme
// de mise a jour de l'etat dans axis_get_motion_status.
// remis axis_go_to_position dans l'ordre correct.
// modifie axis_get_motion_status.
//
// Revision 1.6  2005/04/22 12:14:13  coquet
// added method GetUserEncoderRatio
// used by GalilSlit to manage with slits with motors having differnet UserEncoderRatios.
//
// Revision 1.5  2004/04/19 13:08:40  buteau
// - bug fixe : status not always refreshed
//
// Revision 1.4  2004/04/15 16:47:01  buteau
// clean up methods
//
// Revision 1.3  2004/03/22 13:28:31  buteau
// const signatures in Socket classes
//
// Revision 1.2  2004/03/12 14:18:17  dupuy
// import des binaires
//
// Revision 1.1.1.1  2004/03/12 14:09:00  root
// initial import
//
//
// copyleft :    European Synchrotron Radiation Facility
//               BP 220, Grenoble 38043
//               FRANCE
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#include <tango.h>


int main(int argc,char *argv[])
{

	Tango::Util *tg;
	try
	{
		// Initialise the device server
		//----------------------------------------
		tg = Tango::Util::init(argc,argv);

		// Create the device server singleton 
		//	which will create everything
		//----------------------------------------
		tg->server_init(false);

		// Run the endless loop
		//----------------------------------------
		cout << "Ready to accept request" << endl;
		tg->server_run();
	}
	catch (bad_alloc)
	{
		cout << "Can't allocate memory to store device object !!!" << endl;
		cout << "Exiting" << endl;
	}
	catch (CORBA::Exception &e)
	{
		Tango::Except::print_exception(e);
		
		cout << "Received a CORBA_Exception" << endl;
		cout << "Exiting" << endl;
	}
		//	clean ORB, threads.....
	//--------------------------
#if defined (TANGO_VERSION) &&  TANGO_VERSION> 400
	tg->server_cleanup();
#endif
	return(0);
}
